
ORG100H
PORT_PAGE_0EQU0B0H
PORT_PAGE_1EQU0B1H
PORT_PAGE_2EQU0B2H
PORT_PAGE_3EQU0B3H
PORT_BORDEREQU081H
PORT_FIXBIASEQU080H
PORT_LPLEQU082H
PORT_LPHEQU083H
EXOS_LPTEQU0F900H
JUMP_CODEEQU0C3H
INT_VIDEO_ENABLEEQU10H
INT_VIDEO_MASKEQU20H
PORT_INTERRUPT_CONTROLLEREQU0B4H
JPSTART

PAGE0DB0
PAGE1DB0
PAGE2DB0
PAGE3DB0
INTERRUPT_PUFFER_1DB0
INTERRUPT_PUFFER_2DW0
PALETTEDB0,1,2,3,4,5,6,7
BIASDB0
LPT_CHAR_EDITOR
DB256-41,2,3FH
DS13
LPT_C1
DB256-1,4,19,43,0,0,80H,0AH,0,1,2,3,4,5,6,7;A80HPIXEL160AT
LPT_C2
DB256-4,2,3FH
DS13
DB256-16,52H,31,33,0,0FH,0,0,0,1,2,3,4,5,6,7
DB256-4,2,3FH
DS13
DB256-84,52H,10,51,0,10H,0,0,0,1,2,3,4,5,6,7
DB256-9,8,11,73H,0B8H,0FEH,0E9H,1,0,1,2,3,4,5,6,7
DB256-41,2,3FH
DS13
DB255,1,8,55,0,0,0,0,0,0,0,0,0,0,0,0
INKDB0
START
INA,(PORT_PAGE_1)
LD(PAGE1),A
INA,(PORT_PAGE_2)
LD(PAGE2),A
INA,(PORT_PAGE_3)
LD(PAGE3),A
DI
LDA,(038H)
LD(INTERRUPT_PUFFER_1),A
LDHL,(039H)
LD(INTERRUPT_PUFFER_2),HL
LDA,JUMP_CODE
LD(038H),A
LDHL,INTERRUPT
LD(039H),HL
LDA,0F9H
OUT(0B1H),A
LDA,0FDH
OUT(0B2H),A
LDA,0FCH
OUT(0B3H),A
LDSP,3FFFH
LDHL,4000H
LDDE,4001H
LDBC,49151
LD(HL),0
LDIR
CALLCHAR_EDITOR
END
DI
LDA,(INTERRUPT_PUFFER_1)
LDHL,(INTERRUPT_PUFFER_2)
LD(38H),A
LD(39H),HL
LDA,(PAGE1)
OUT(PORT_PAGE_1),A
LDA,(PAGE2)
OUT(PORT_PAGE_2),A
LDA,(PAGE3)
OUT(PORT_PAGE_3),A
LDA,LOW(EXOS_LPT/16)
OUT(PORT_LPL),A
LDA,(HIGH(EXOS_LPT/16))+0C0H
OUT(PORT_LPH),A
RET
INTERRUPT
PUSHAF
LDA,INT_VIDEO_ENABLE+INT_VIDEO_MASK
OUT(PORT_INTERRUPT_CONTROLLER),A
POPAF
EI
RET
CHAR_EDITOR
LDA,0F9H
OUT(PORT_PAGE_1),A
LDA,0FDH
OUT(PORT_PAGE_2),A
LDA,0FFH
OUT(PORT_PAGE_3),A
LDH,40
LDL,53
LD(POS_X),HL
LDHL,82-4
LD(SCREEN_WIDTH),HL
LDHL,-16*82+4
LD(SCREEN_WIDTH_16),HL
LDDE,0C000H
LDHL,LPT_CHAR_EDITOR
LDBC,10H
LDIR
LDHL,-24
LD(LPT_C1+6),HL
LDHL,0A80H
LD(LPT_C1+4),HL
EXX
LDB,32
LDC,16
CALLLPT_BUILT
LDHL,(LPT_C1+4)
LDDE,24
ADDHL,DE
LD(LPT_C1+4),HL
LDB,80
LDC,4
CALLLPT_BUILT
EXX
LDHL,LPT_C2
LDBC,INK-LPT_C2
LDIR
LDHL,0C010H
CALLSET_PALETTE
LDHL,0C711H
SET7,(HL)
XORA
OUT(PORT_LPL),A
LDA,0CCH
OUT(PORT_LPH),A
LDA,0FCH
OUT(PORT_PAGE_3),A
LDHL,0C000H
LDDE,0C001H
LDBC,0A80H
LD(HL),L
LDIR
LDBC,528
LD(HL),8FH
LDIR
LDHL,0D000H
LDDE,0D001H
LDBC,6888
LD(HL),0
LDIR
LDIX,ICON_PRINT_TABLE
CALLICON_PRINT
;CALLGRID_PRINT
CALLX_PRINT
LDIX,PALETTE
LDHL,0CA80H+4
LDB,16
COLO1
LDA,16
SUBB
CALLPAPER_TO_INK
LD(HL),A
INCHL
DJNZCOLO1
EI
CALLCHAR_SET_PRINT
CALLBORDER_LINE
JPCLS
SPRINT
CALLPIXEL_TO_SCREEN
CALLWAIT_SPACE
JRSPRINT0
SPRINT01
CALLPIXEL_TO_SCREEN
SPRINT0
CALLSPRITE_TO_SCREEN
HALT
CALLSPRITE_TO_SCREEN
LDIX,POS_X
LDHL,STEP
LDA,7
OUT(0B5H),A
INA,(0B5H)
BIT5,A
CALLZ,LEFT
BIT2,A
CALLZ,RIGHT
INCIX
BIT3,A
CALLZ,UP
BIT1,A
CALLZ,DOWN
INCA
JRZ,SPRINT2
LDHL,STEP_COUNTER
DEC(HL)
JRNZ,SPRINT3
LD(HL),15
DECHL
INC(HL)
JRSPRINT3
SPRINT2
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
SPRINT3
LDA,8
OUT(0B5H),A
INA,(0B5H)
BIT6,A
JRZ,FIRE
JRSPRINT0
FIRE
CALLCORDINAT
LDA,L
LDC,L
INCA
JRZ,SPRINT
ADDHL,HL
LDDE,(ICON_JUMP_TABLE_ADDRESS)
ADDHL,DE
LDA,(HL)
INCHL
LDH,(HL)
LDL,A
PUSHHL
LDA,C
CPUNDO_CODE
JPNZ,UNDO_SCREEN_TO_PUFFER
RET
UNDO_CODEEQU12
DOWN
LDB,95
PUSHAF
LDA,(POS_Y)
ADDA,(HL)
CP96+4
JPNC,TOGGLE_SCREEN_DOWN
LD(POS_Y),A
LOOP_C
POPAF
RET
UP
LDB,0
PUSHAF
LDA,(POS_Y)
SUB(HL)
JPC,LOOP_D
LD(POS_Y),A
JRLOOP_C
LOOP_D
LD(IX),B
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
POPAF
RET
LEFT
LDB,0
PUSHAF
LDA,(POS_X)
SUB(HL)
JRC,LOOP_D
LD(POS_X),A
JPLOOP_C
RIGHT
LDB,185
PUSHAF
LDA,(POS_X)
ADDA,(HL)
CP186
JRNC,LOOP_D
LD(POS_X),A
JPLOOP_C
LPT_BUILT
LDA,C
INCA
LDDE,24
LDIX,(LPT_C1+6)
LDIY,(LPT_C1+4)
LPTB2
ADDIX,DE
LD(LPT_C1+6),IX
DECA
JRNZ,LPTB1
LDA,C
ADDIY,DE
LD(LPT_C1+4),IY
LPTB1
EXX
LDHL,LPT_C1
LDBC,10H
LDIR
EXX
DJNZLPTB2
RET
POS_XDB53
POS_YDB40
STEPDB1
STEP_COUNTERDB15
ARROWDB80H,80H,0C0H,0C0H,0E0H,0E0H,0F0H,0F0H,0F8H,0E0H,90H,10H,10H
DB8,8
IY_CODEEQU0FDH
HEIGTHEQU15
SPRITE_TO_SCREEN
LDA,(POS_Y)
LDL,A
LDH,0
ADDHL,HL
ADDHL,HL
ADDHL,HL
LDE,L
LDD,H
ADDHL,HL
ADDHL,DE
LDA,(POS_X)
SRLA
SRLA
SRLA
LDE,A
LDD,0C0H
ADDHL,DE
LDDE,ARROW
LDA,(POS_X)
AND7
DBIY_CODE
LDL,A
DBIY_CODE
LDH,HEIGTH
STS4
DBIY_CODE
LDB,L
LDA,(DE)
INCDE
LDC,0
INCB
DECB
JPZ,STS2
ORA
STS1
RRA
RRC
DJNZSTS1
STS2
XOR(HL)
LD(HL),A
INCHL
LDA,C
XOR(HL)
LD(HL),A
LDA,23
ADDA,L
LDL,A
JPNC,STS3
INCH
STS3
DBIY_CODE
DECH
JPNZ,STS4
RET
CORDINAT
LDDE,(POS_X)
INCE
INCD
LDBC,4
LDIX,CORDINAT_TABLE
LDHL,0
COR2
LDA,(IX)
CP0FFH
JRZ,COR1
CPE
JRNC,CNEXT
LDA,(IX+1)
CPD
JRNC,CNEXT
LDA,(IX+2)
INCA
CPE
JRC,CNEXT
LDA,(IX+3)
INCA
CPD
JRC,CNEXT
RET
CNEXT
INCL
ADDIX,BC
JRCOR2
COR1
LDL,0FFH
RET
EXIT_CHAR_EDIT
RET
SEQU16
P_SIZEEQU8
CORDINAT_TABLE
DB2*S,3*S,3*S-1,4*S-1;EXIT
DB2*S,S,3*S-1,2*S-1;CLS
DB3*S,S,4*S-1,2*S-1;PALETTE
DB4*S,S,5*S-1,2*S-1;ROTATEUP
DB5*S,S,6*S-1,2*S-1;ROTATEDOWN
DB6*S,S,7*S-1,2*S-1;ROTATELEFT
DB7*S,S,8*S-1,2*S-1;ROTATERIGHT
DB8*S,S,9*S-1,2*S-1;FLIPVERTICAL
DB9*S,S,10*S-1,2*S-1;FLIPHORISONTAL
DB4*S,2*S,8*S-1,6*S-1;DRAW
DB2*S,2*S,3*S-1,3*S-1;INVERT
DB3*S,2*S,4*S-1,3*S-1;COPYRIGHT
DB3*S,3*S,4*S-1,4*S-1;UNDO
DB2*S,4*S,3*S-1,5*S-1;CHARSET1
DB3*S,4*S,4*S-1,5*S-1;CHARSET2
DB8*S,2*S,9*S-1,3*S-1;SAVECHARS
DB9*S,2*S,10*S-1,3*S-1;LOADCHARS
DB8*S,3*S,9*S-1,4*S-1;PUTCHAR
DB9*S,3*S,10*S-1,4*S-1;GETCHAR
DB8*S,4*S,9*S-1,5*S-1;CHARSET3
DB9*S,4*S,10*S-1,5*S-1;CHARSET4
DB2*S,0,10*S-1,S-1;SELECT_INK
DB0FFH
ICON_JUMP_TABLE
DWNOTHING;EXIT
DWCLS;CLS
DWSELECT_PALETTE;PALETTE
DWROTATE_UP;RU
DWROTATE_DOWN;RD
DWROTATE_LEFT;RL
DWROTATE_RIGHT;RR
DWFLIP_VERTICAL;FV
DWFLIP_HORIZONTAL;FH
DWDRAW;DRAW
DWINVERT;INVERT
DWBLOCK_EDITOR;COPYRIGHT
DWUNDO;UNDO
DWCHAR_SET_1;CHARSET1
DWCHAR_SET_2;CHARSET2
DWSAVE_FILE;SAVECHARS
DWLOAD_FILE;LOADCHARS
DWPUT;PUTCHAR
DWGET;GETCHAR
DWCHAR_SET_3;CHARSET3
DWCHAR_SET_4;CHARSET4
DWSELECT_INK;INK
NOTHING
JPSPRINT
ICON_PRINT_TABLE
DB1,2,17,1,3,11,1,4,0,1,5,1,1,6,2,1,7,3,1,8,4,1,9,5
DB2,2,16,2,3,6,3,2,9,3,3,10,4,2,12,4,3,13,4,8,14,4,9,15
DB2,8,7,2,9,8,3,8,18,3,9,19,0FFH

ICON_DATA
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB80H,1,80H,1,80H,1,80H,1
DEFB80H,1,80H,1,80H,1,80H,1
DEFB80H,1,80H,1,80H,1,80H,1
DEFB80H,1,80H,1,80H,1,80H,1
DEFB0FFH,0FFH,80H,1,80H,1,80H,1
DEFB81H,81H,81H,81H,80H,1,80H,1
DEFB82H,41H,80H,1,83H,0C1H,9FH,0F9H
DEFB9FH,0F9H,0BFH,0E1H,0A2H,45H,8FH,0C1H
DEFB80H,1,9CH,1,9CH,39H,9CH,39H
DEFB0F8H,1FH,9DH,0DH,81H,81H,81H,81H
DEFB81H,81H,81H,81H,80H,1,80H,1
DEFB82H,41H,81H,1,8CH,31H,90H,9
DEFB90H,9,0A0H,21H,0A2H,65H,90H,21H
DEFB80H,1,0BEH,1,0BEH,7DH,0BEH,7DH
DEFB0FCH,3FH,0A1H,11H,81H,81H,81H,81H
DEFB83H,0C1H,81H,81H,80H,81H,81H,1
DEFB86H,41H,81H,0C1H,90H,9,90H,9
DEFB90H,9,0A0H,3DH,0A2H,55H,91H,91H
DEFB80H,1,0BEH,1,0BEH,7DH,0BEH,7DH
DEFB0FEH,7FH,0A1H,11H,81H,81H,83H,0C1H
DEFB83H,0C1H,81H,81H,83H,81H,81H,0C1H
DEFB86H,41H,81H,0F1H,91H,0C9H,91H,89H
DEFB91H,89H,0A0H,25H,0A2H,4DH,0A1H,89H
DEFB83H,81H,0BEH,1,0BEH,7DH,0BEH,7DH
DEFB0FEH,7FH,0A1H,11H,87H,0E1H,83H,0C1H
DEFB87H,0E1H,81H,81H,8FH,81H,81H,0F1H
DEFB8EH,41H,0BFH,0FDH,0A2H,5,91H,89H
DEFB91H,89H,0A0H,25H,9CH,45H,0ACH,35H
DEFB87H,0C1H,9CH,1,9CH,39H,9CH,39H
DEFB0FEH,7FH,0A1H,11H,87H,0E1H,87H,0E1H
DEFB87H,0E1H,8FH,0F1H,0BFH,0FDH,0BFH,0FDH
DEFB8EH,79H,80H,1,0A4H,5,90H,9
DEFB90H,9,0A0H,25H,80H,1,0ACH,35H
DEFB87H,0C1H,80H,1,80H,1,80H,1
DEFB0FEH,7FH,0A1H,9,83H,0C1H,87H,0E1H
DEFB8FH,0F1H,87H,0E1H,0BFH,0FDH,0BFH,0FDH
DEFB9EH,71H,80H,1,0A4H,5,91H,89H
DEFB91H,89H,0A0H,25H,80H,1,0A0H,5
DEFB87H,0C1H,80H,1,80H,1,80H,1
DEFB0FEH,7FH,0A1H,5,83H,0C1H,81H,81H
DEFB81H,81H,87H,0E1H,8FH,81H,81H,0F1H
DEFB82H,71H,0BFH,0FDH,0A2H,5,91H,89H
DEFB91H,89H,0A0H,25H,0BCH,39H,0AEH,5
DEFB83H,81H,80H,39H,83H,81H,9CH,39H
DEFB0FEH,7FH,0A1H,5,81H,81H,81H,81H
DEFB81H,81H,83H,0C1H,83H,81H,81H,0C1H
DEFB82H,61H,8FH,81H,91H,0C9H,9FH,0F9H
DEFB9FH,0F9H,0BFH,0E5H,0A2H,45H,0B1H,65H
DEFB80H,1,80H,7DH,87H,0C1H,0BEH,7DH
DEFB0FEH,7FH,0A1H,5,81H,81H,81H,81H
DEFB81H,81H,83H,0C1H,80H,81H,81H,1
DEFB82H,61H,83H,81H,90H,9,80H,1
DEFB80H,1,84H,5,0A2H,45H,81H,65H
DEFB80H,1,80H,7DH,87H,0C1H,0BEH,7DH
DEFB0FEH,7FH,0A1H,5,80H,1,80H,1
DEFB81H,81H,81H,81H,80H,1,80H,1
DEFB82H,41H,80H,81H,8CH,31H,81H,81H
DEFB87H,0E1H,87H,0FDH,0A2H,45H,82H,9
DEFB80H,1,80H,7DH,87H,0C1H,0BEH,7DH
DEFB0FCH,3FH,0A1H,5,0BFH,0FDH,0BFH,0FDH
DEFB81H,81H,81H,81H,80H,1,80H,1
DEFB82H,41H,80H,1,83H,0C1H,83H,0C1H
DEFB83H,0C1H,80H,1,0BCH,39H,87H,0F1H
DEFB80H,1,80H,39H,83H,81H,9CH,39H
DEFB0F8H,1FH,9DH,0D9H,0BFH,0FDH,0BFH,0FDH
DEFB80H,1,80H,1,80H,1,80H,1
DEFB80H,1,80H,1,80H,1,87H,0E1H
DEFB81H,81H,80H,1,80H,1,80H,1
DEFB80H,1,80H,1,80H,1,80H,1
DEFB0FFH,0FFH,80H,1,80H,1,80H,1
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
ICON_PRINT
LDA,(IX)
CP0FFH
RETZ
LDL,A
LDH,0
ADDHL,HL
ADDHL,HL
ADDHL,HL
ADDHL,HL
LDD,H
LDE,L
ADDHL,HL
ADDHL,DE
ADDHL,HL
ADDHL,HL
ADDHL,HL
LDDE,06000H
ADDHL,DE
INCIX
LDA,(IX)
ADDA,A
LDE,A
ADDHL,DE
INCIX
LDA,(IX)
ADDA,A
INCIX
LDC,A
LDB,0
EXDE,HL
LDHL,ICON_DATA
ADDHL,BC
LDB,16
ICP1
LDA,(HL)
LD(DE),A
INCHL
INCDE
LDA,(HL)
LD(DE),A
LDA,B
LDBC,39
ADDHL,BC
EXDE,HL
LDC,23
ADDHL,BC
EXDE,HL
LDB,A
DJNZICP1
JPICON_PRINT
GRID_PRINT
LDHL,0C000H+8+2*16*24
PUSHHL
LDDE,16
LDC,64
LDA,1
GP2
LDB,8
GP1
LD(HL),A
INCHL
DJNZGP1
ADDHL,DE
DECC
JRNZ,GP2
LDHL,0C000H+7+80*24
LDB,16
LDDE,24
GP3
LD(HL),A
ADDHL,DE
DJNZGP3
POPHL
LDDE,3*24
ADDHL,DE
LDA,0FFH
LDC,16
LDDE,4*24-8
GP5
LDB,8
GP4
LD(HL),A
INCHL
DJNZGP4
ADDHL,DE
DECC
JRNZ,GP5
RET
X_PRINT
LDA,(INK)
ADDA,4+6*24
LDL,A
LDH,0C0H
LDDE,24
LDA,044H
XOR(HL)
LD(HL),A
ADDHL,DE
LDA,028H
XOR(HL)
LD(HL),A
ADDHL,DE
LDA,010H
XOR(HL)
LD(HL),A
ADDHL,DE
LDA,028H
XOR(HL)
LD(HL),A
ADDHL,DE
LDA,044H
XOR(HL)
LD(HL),A
RET
SELECT_INK
CALLX_PRINT
LDA,(POS_X)
SUB32
SRLA
SRLA
SRLA
LD(INK),A
CALLX_PRINT
JPSPRINT
DRAW
LDA,(POS_X)
SRLA
SRLA
SRLA
LDB,A
LDA,(POS_Y)
SUB32
AND0FCH
LDL,A
LDH,0
ADDHL,HL
LDD,H
LDE,L
ADDHL,HL
ADDHL,DE
LDE,B
ADDHL,DE
LDDE,0CA80H+2*4*6
ADDHL,DE
LDA,(INK)
LDIX,PALETTE
CALLPAPER_TO_INK
LD(HL),A
JPSPRINT01
WAIT_SPACE
LDA,8
OUT(0B5H),A
INA,(0B5H)
BIT6,A
JRZ,WAIT_SPACE
RET
ROTATE_PUFFERDS16
ROTATE_UP
LDHL,0CA80H+24*2+8
LDDE,ROTATE_PUFFER
LDBC,8
LDIR
LDHL,0CA80H+24*3+8
LDDE,0CA80H+24*2+8
EXX
LDB,15
RU1
EXX
LDBC,8
LDIR
LDBC,16
ADDHL,BC
EXDE,HL
ADDHL,BC
EXDE,HL
EXX
DJNZRU1
EXX
LDHL,ROTATE_PUFFER
LDBC,8
LDIR
JPSPRINT
ROTATE_DOWN
LDHL,0CA80H+18*24-9
PUSHHL
LDDE,ROTATE_PUFFER+7
LDBC,8
LDDR
POPDE
LDHL,0CA80H+17*24-9
EXX
LDB,15
RD1
EXX
LDBC,8
LDDR
LDBC,-16
ADDHL,BC
EXDE,HL
ADDHL,BC
EXDE,HL
EXX
DJNZRD1
LDDE,0CA80H+2*24+15
LDHL,ROTATE_PUFFER+7
LDBC,8
LDDR
JPSPRINT
ROTATE_LEFT
LDHL,0CA80H+2*24+8
PUSHHL
LDDE,ROTATE_PUFFER
LDB,16
RL1
LDA,(HL)
LD(DE),A
INCDE
LDA,B
LDBC,24
ADDHL,BC
LDB,A
DJNZRL1
POPDE
PUSHDE
POPHL
INCHL
LDA,16
RL2
LDBC,7
LDIR
LDBC,17
ADDHL,BC
EXDE,HL
ADDHL,BC
EXDE,HL
DECA
JRNZ,RL2
LDBC,23
LDA,16
LDDE,0CA80H+24*2+15
LDHL,ROTATE_PUFFER
RL3
LDI
INCBC
EXDE,HL
ADDHL,BC
EXDE,HL
DECA
JRNZ,RL3
JPSPRINT
ROTATE_RIGHT
LDHL,0CA80H+2*24+15
PUSHHL
LDDE,ROTATE_PUFFER
LDB,16
RR1
LDA,(HL)
LD(DE),A
INCDE
LDA,B
LDBC,24
ADDHL,BC
LDB,A
DJNZRR1
POPDE
PUSHDE
POPHL
DECHL
LDA,16
RR2
PUSHHL
PUSHDE
LDBC,7
LDDR
POPDE
POPHL
LDBC,24
ADDHL,BC
EXDE,HL
ADDHL,BC
EXDE,HL
DECA
JRNZ,RR2
LDBC,23
LDA,16
LDDE,0CA80H+24*2+8
LDHL,ROTATE_PUFFER
RR3
LDI
INCBC
EXDE,HL
ADDHL,BC
EXDE,HL
DECA
JRNZ,RR3
JPSPRINT
FLIP_HORIZONTAL
LDIX,0CA80H+24*2+8
LDDE,24
LDB,16
FH1
LDA,(IX)
LDC,(IX+7)
LD(IX+7),A
LD(IX),C
LDA,(IX+1)
LDC,(IX+6)
LD(IX+6),A
LD(IX+1),C
LDA,(IX+2)
LDC,(IX+5)
LD(IX+5),A
LD(IX+2),C
LDA,(IX+3)
LDC,(IX+4)
LD(IX+4),A
LD(IX+3),C
ADDIX,DE
DJNZFH1
JPSPRINT
FLIP_VERTICAL
LDIX,0CA80H+24*2+8
LDHL,0CA80H+24*17+8
LDB,8
FV2
LDC,8
PUSHHL
PUSHIX
FV1
LDA,(IX)
LDE,(HL)
LD(IX),E
LD(HL),A
INCIX
INCHL
DECC
JRNZ,FV1
POPIX
POPHL
LDDE,24
ADDIX,DE
SBCHL,DE
DJNZFV2
JPSPRINT
CLS
LDA,(INK)
LDIX,PALETTE
CALLPAPER_TO_INK
LDHL,0CA80H+2*24+8
LDDE,16
LDC,16
CL2
LDB,8
CL1
LD(HL),A
INCHL
DJNZCL1
ADDHL,DE
DECC
JRNZ,CL2
JPSPRINT
UNDO_PUFFER
DS8*16
UNDO
LDIX,UNDO_PUFFER
LDHL,0CA80H+2*24+8
LDC,16
UN2
LDB,8
UN1
LDA,(IX)
LDD,(HL)
LD(IX),D
LD(HL),A
INCHL
INCIX
DJNZUN1
LDDE,16
ADDHL,DE
DECC
JRNZ,UN2
JPSPRINT
UNDO_SCREEN_TO_PUFFER
LDIX,UNDO_PUFFER
LDHL,0CA80H+2*24+8
LDDE,16
LDC,16
UND2
LDB,8
UND1
LDA,(HL)
LD(IX),A
INCHL
INCIX
DJNZUND1
LDDE,16
ADDHL,DE
DECC
JRNZ,UND2
RET
SET_PALETTE
INA,(PORT_PAGE_3)
PUSHAF
PUSHIX
LDA,0FFH
OUT(0B3H),A
SP2
LDDE,7
INCHL
PUSHHL
POPIX
BIT0,(IX+32)
JRNZ,SP1
ADDHL,DE
EXDE,HL
LDHL,PALETTE
LDBC,8
LDIR
EXDE,HL
JRSP2
SP1
POPIX
POPAF
OUT(PORT_PAGE_3),A
RET
PAPER_TO_INK
LDE,A
CP8
JRNC,P1
LD(P2+2),A
P2
LDA,(IX+0)
P1
AND2
LDA,8
JRNZ,P3
LDA,0FH
P3
RLCE
RLCE
RLCE
RLCE
ORE
RET
INTENSITI_TABLE
DB0,64,8,72,1,65,9,73
COLOR_SKALA
INA,(PORT_PAGE_2)
PUSHAF
LDA,0FFH
OUT(PORT_PAGE_2),A
LDIX,8008H+33*16
LDC,8
CO1
LDB,8
CO2
LDA,8
SUBB
ADDA,LOWINTENSITI_TABLE
LDH,HIGHINTENSITI_TABLE
LDL,A
JRNC,CO3
INCH
CO3
LDE,(HL)
LDA,8
SUBC
ADDA,LOWINTENSITI_TABLE
LDL,A
LDH,HIGHINTENSITI_TABLE
JRNC,CO4
INCH
CO4
LDA,(HL)
RLCA
ORE
LDE,A
LDA,(BLUE)
ORE
LD(IX),A
LD(IX+16),A
LD(IX+32),A
LD(IX+48),A
LD(IX+64),A
LD(IX+80),A
LD(IX+96),A
LD(IX+112),A
INCIX
DJNZCO2
LDDE,8*16-8
ADDIX,DE
DECC
JRNZ,CO1
LDIX,8008H+33*16
LDIY,0CA80H+2*24+8
LDC,8
CO11
LDB,8
CO10
LDA,8
SUBB
CALLPAPER_TO_INK
LD(IY),A
LD(IY+24),A
INCIY
DJNZCO10
LDDE,48-8
ADDIY,DE
LDDE,8*16
ADDIX,DE
DECC
JRNZ,CO11
POPAF
OUT(PORT_PAGE_2),A
RET
BLUEDB0
ICON_JUMP_TABLE_ADDRESSDWICON_JUMP_TABLE
SELECT_PALETTE
LDHL,ICON_JUMP_TABLE_2
LD(ICON_JUMP_TABLE_ADDRESS),HL
LDHL,UNDO_PUFFER
LDDE,UNDO_PUFFER_2
LDBC,8*16
LDIR
CALLCOLOR_SKALA
JPSPRINT
UNDO_PUFFER_2
DS8*16
EXIT_PALETTE
LDHL,UNDO_PUFFER_2
LDDE,UNDO_PUFFER
LDBC,8*16
LDIR
LDHL,ICON_JUMP_TABLE
LD(ICON_JUMP_TABLE_ADDRESS),HL
LDHL,0C010H
CALLSET_PALETTE
JPUNDO
SKALA_1
XORA
SKALA_
LD(BLUE),A
CALLCOLOR_SKALA
JPSPRINT
SKALA_2
LDA,32
JRSKALA_
SKALA_3
LDA,4
JRSKALA_
SKALA_4
LDA,36
JRSKALA_
ICON_JUMP_TABLE_2
DWEXIT_PALETTE;EXIT
DWNOTHING;CLS
DWNOTHING;PALETTE
DWNOTHING;RU
DWNOTHING;RD
DWNOTHING;RL
DWNOTHING;RR
DWNOTHING;FV
DWNOTHING;FH
DWSELECT_COLOR;DRAW
DWNOTHING;INVERT
DWNOTHING;COPYRIGHT
DWNOTHING;UNDO
DWSKALA_1;CHARSET1
DWSKALA_2;CHARSET2
DWNOTHING;SAVECHARS
DWNOTHING;LOADCHARS
DWNOTHING;PUTCHAR
DWNOTHING;GETCHAR
DWSKALA_3;CHARSET3
DWSKALA_4;CHARSET4
DWSELECT_INK;INK
SELECT_COLOR
LDA,(POS_Y)
LDL,A
LDH,0
ADDHL,HL
ADDHL,HL
ADDHL,HL
ADDHL,HL
LDDE,08018H
ADDHL,DE
LDA,(POS_X)
SUB64
SRLA
SRLA
SRLA
AND7
LDE,A
LDD,0
ADDHL,DE
INA,(PORT_PAGE_2)
PUSHAF
LDA,0FFH
OUT(PORT_PAGE_2),A
LDB,(HL)
LDA,(INK)
CP8
JRNC,SBIAS
LDE,A
LDHL,PALETTE
ADDHL,DE
LD(HL),B
SC1
LDHL,8010H
CALLSET_PALETTE
CALLCOLOR_SKALA
POPAF
OUT(PORT_PAGE_2),A
JPSPRINT
SBIAS
SRLB
SRLB
SRLB
LDA,B
OUT(PORT_FIXBIAS),A
LD(BIAS),A
JRSC1
DATA_TO_PIXEL
AND0FH
RRA
RRC
SRAC
ADDA,0FCH
RRC
SRAC
RRA
RRC
SRAC
RRA
RRC
SRAC
LDA,C
RRCA
RRCA
RET
PIXEL_TO_DATA
LDC,A
ADDA,0C0H
RLC
ORC
RRA
AND15H
ADDA,0F0H
RLA
AND0FH
ADDA,0F8H
RLA
RRC
RLA
AND0FH
RET
PIXEL_TO_SCREEN
LDC,16
LDIX,0CA80H+2*24+8
LDHL,0CF00H
PTS2
LDB,4
PTS1
EXX
LDA,(IX)
SRLA
SRLA
SRLA
SRLA
INCIX
CALLDATA_TO_PIXEL
RLCA
AND0AAH
LDE,A
LDA,(IX)
SRLA
SRLA
SRLA
SRLA
INCIX
CALLDATA_TO_PIXEL
AND55H
ORE
EXX
LD(HL),A
INCHL
DJNZPTS1
LDDE,16
ADDIX,DE
DECC
JRNZ,PTS2
RET
NYIL_DATA_0
DEFB0FFH,0,0FFH,0,0FFH,0,0AAH,55H
DEFB0,0FFH,55H,0AAH,0FFH,0,0FFH,0
DEFB0,0FFH,0,0FFH,0,0FFH,0FFH,0
DEFB0FFH,0,0AAH,55H,0,0FFH,0,0FFH
DEFB55H,0AAH,0AAH,55H,55H,0AAH,0AAH,55H
DEFB0,0FFH,0,0FFH,0AAH,55H,0,0FFH
DEFB0,0FFH
NYIL_DATA_1
DEFB55H,0AAH,0FFH,0,0FFH,0,0FFH,0
DEFB0,0FFH,0,0FFH,0FFH,0,0FFH,0
DEFB0AAH,55H,0,0FFH,0,0FFH,55H,0AAH
DEFB0FFH,0,0FFH,0,0,0FFH,0,0FFH
DEFB0,0FFH,0FFH,0,0,0FFH,0FFH,0
DEFB0,0FFH,0,0FFH,55H,0AAH,0,0FFH
DEFB0,0FFH
SCREEN_WIDTHDW82-4
SPTOSC;DEMUTATASPRITERE,HLAKEPERNYORE
LD(SPSC1+1),SP
DI
EXDE,HL
LDSP,HL
EXDE,HL
LDBC,(SCREEN_WIDTH)
DBIY_CODE
LDL,5
SPSC2
POPDE
LDA,(HL)
ANDD
ORE
LD(HL),A
INCHL
POPDE
LDA,(HL)
ANDD
ORE
LD(HL),A
INCHL
POPDE
LDA,(HL)
ANDD
ORE
LD(HL),A
INCHL
POPDE
LDA,(HL)
ANDD
ORE
LD(HL),A
INCHL
POPDE
LDA,(HL)
ANDD
ORE
LD(HL),A
ADDHL,BC
DEFBIY_CODE
DECL
JPNZ,SPSC2
SPSC1
LDSP,200H
EI
RET
SPRITE_PUFFER
DS25
SCTOPU
LD(SCPU1+1),SP
DI
LDSP,(SCREEN_WIDTH)
DECSP
LDBC,5*5
LDDE,SPRITE_PUFFER
SCPU2
LDI
LDI
LDI
LDI
LDI
ADDHL,SP
JPPE,SCPU2
SCPU1
LDSP,200H
EI
RET
PUTOSC
EXDE,HL
LD(PUSC1+1),SP
DI
LDSP,(SCREEN_WIDTH)
DECSP
LDBC,25
LDHL,SPRITE_PUFFER
PUSC2
LDI
LDI
LDI
LDI
LDI
EXDE,HL
ADDHL,SP
EXDE,HL
JPPE,PUSC2
PUSC1
LDSP,200H
EI
RET
GETSCADD;BC=Y,X
LDBC,(POS_X)
LDL,B
LDH,0
LDA,C
ADDHL,HL
LDC,L
LDB,H
ADDHL,HL
ADDHL,HL
ADDHL,HL
LDD,H
LDE,L
ADDHL,HL
ADDHL,HL
ADDHL,DE
ADDHL,BC
SRLA
LDC,A
LDB,0
ADDHL,BC
LDBC,0D000H
ADDHL,BC
RET
CONTROL
CALLGETSCADD
PUSHHL
CALLSCTOPU
POPHL
PUSHHL
LDA,(POS_X)
LDDE,NYIL_DATA_0
RRCA
JRNC,CON1
LDDE,NYIL_DATA_1
CON1
CALLSPTOSC
HALT
POPHL
CALLPUTOSC
LDIX,POS_X
LDHL,STEP
LDA,7
OUT(0B5H),A
INA,(0B5H)
BIT5,A
CALLZ,LEFT_
BIT2,A
CALLZ,RIGHT_
INCIX
BIT3,A
CALLZ,UP_
BIT1,A
CALLZ,DOWN_
INCA
JRZ,SPRINT2_
LDHL,STEP_COUNTER
DEC(HL)
JRNZ,SPRINT3_
LD(HL),15
DECHL
INC(HL)
JRSPRINT3_
SPRINT2_
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
SPRINT3_
LDA,8
OUT(0B5H),A
INA,(0B5H)
BIT6,A
JRZ,FIRE_
JRCONTROL
FIRE_
CALLBORDER_LINE
LDBC,(POS_X)
LDE,-1
LDA,B
DIV_20
SUB20
INCE
JRNC,DIV_20
LDD,-1
LDA,C
DIV_10
SUB10
INCD
JRNC,DIV_10
LDA,E
RLCA
RLCA
RLCA
RLCA
ADDA,D
LD(CHAR_POS),A
CALLBORDER_LINE
JPCONTROL
DOWN_
LDB,79
PUSHAF
LDA,(POS_Y)
ADDA,(HL)
CP80
JRNC,LOOP_D_
LD(POS_Y),A
LOOP_C_
POPAF
RET
UP_
LDB,0
PUSHAF
LDA,(POS_Y)
SUB(HL)
JPC,TOGGLE_SCREEN_UP
LD(POS_Y),A
JRLOOP_C_
LOOP_D_
LD(IX),B
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
POPAF
RET
LEFT_
LDB,0
PUSHAF
LDA,(POS_X)
SUB(HL)
JRC,LOOP_D_
LD(POS_X),A
JPLOOP_C_
RIGHT_
LDB,154
PUSHAF
LDA,(POS_X)
ADDA,(HL)
CP155
JRNC,LOOP_D_
LD(POS_X),A
JPLOOP_C_
BORDER_LINE
LDA,(CHAR_POS)
LDB,A
AND15
LDC,A
ADDA,A
ADDA,A
ADDA,C
LDC,A
SRLB
SRLB
SRLB
SRLB
LDDE,20*82
LDHL,0
JRZ,BOR2
BOR1
ADDHL,DE
DJNZBOR1
BOR2
LDB,0
ADDHL,BC
LDBC,0D000H+2*82
ADDHL,BC
CALLBOR3
LDDE,82
PUSHHL
POPIX
LDB,16
BOR4
LDA,(IX)
XOR15H
LD(IX),A
LDA,(IX+5)
XOR2AH
LD(IX+5),A
ADDIX,DE
DJNZBOR4
PUSHIX
POPHL
BOR3
LDDE,82-5
LDC,2
BOR5
LDB,4
LDA,(HL)
XOR15H
LD(HL),A
INCHL
BOR6
LDA,(HL)
XOR3FH
LD(HL),A
INCHL
DJNZBOR6
LDA,(HL)
XOR2AH
LD(HL),A
ADDHL,DE
DECC
JRNZ,BOR5
RET
TOGGLE_SCREEN_UP
INA,(PORT_PAGE_3)
LDB,A
LDA,0FFH
OUT(PORT_PAGE_3),A
LDHL,0C761H
RES7,(HL)
LDHL,0C711H
SET7,(HL)
LDA,B
OUT(PORT_PAGE_3),A
POPAF
POPAF
LDA,93
LD(POS_Y),A
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
JPSPRINT
TOGGLE_SCREEN_DOWN
INA,(PORT_PAGE_3)
LDB,A
LDA,0FFH
OUT(PORT_PAGE_3),A
LDHL,0C711H
RES7,(HL)
LDHL,0C761H
SET7,(HL)
LDA,B
OUT(PORT_PAGE_3),A
POPAF
POPAF
LDA,0
LD(POS_Y),A
LDA,(POS_X)
SRLA
ADDA,34
LD(POS_X),A
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
JPCONTROL
CHAR_POSDB0
CHAR_SET_PRINT
LDA,(CHAR_SET)
RRCA
RRCA
LDL,A
LDIX,0D000H+4*82+1
LDDE,82*4
LDA,4
LDH,40H
CSP3
EXAF,AF
LDC,16
CSP2
LDB,16
CSP1
LDA,(HL)
LD(IX),A
INCH
INCIX
LDA,(HL)
LD(IX),A
INCH
INCIX
LDA,(HL)
LD(IX),A
INCH
INCIX
LDA,(HL)
LD(IX),A
DECH
DECH
DECH
INCL
INCIX
INCIX
DJNZCSP1
INCIX
INCIX
INCH
INCH
INCH
INCH
LDA,L
SUB16
LDL,A
DECC
JRNZ,CSP2
ADDIX,DE
LDA,L
ADDA,16
LDL,A
EXAF,AF
LDH,40H
DECA
JRNZ,CSP3
RET
CHAR_SETDB0
CHAR_SET_1
XORA
CHS1
LD(CHAR_SET),A
CALLCHAR_SET_PRINT
JPSPRINT
CHAR_SET_2
LDA,1
JRCHS1
CHAR_SET_3
LDA,2
JRCHS1
CHAR_SET_4
LDA,3
JRCHS1
PUT
LDB,64
LDHL,0CF00H
LDA,(CHAR_SET)
RRCA
RRCA
LDE,A
LDD,40H
LDA,(CHAR_POS)
ADDA,E
LDE,A
PUT1
LDA,(HL)
INCHL
LD(DE),A
INCD
DJNZPUT1
CALLCHAR_SET_PRINT
JPSPRINT
SCREEN_TO_PIXEL
LDIX,PALETTE
LDC,16
LDIY,0CA80H+2*24+8
EXX
LDHL,0CF00H
EXX
STP2
LDB,4
STP1
EXX
LDA,(HL)
AND55H
CALLPIXEL_TO_DATA
CALLPAPER_TO_INK
LD(IY+1),A
LDA,(HL)
RRCA
AND55H
CALLPIXEL_TO_DATA
CALLPAPER_TO_INK
LD(IY),A
INCHL
INCIY
INCIY
EXX
DJNZSTP1
LDDE,16
ADDIY,DE
DECC
JRNZ,STP2
RET
GET
LDA,(CHAR_SET)
RRCA
RRCA
LDE,A
LDA,(CHAR_POS)
ADDA,E
LDE,A
LDD,40H
LDHL,0CF00H
LDB,64
GET1
LDA,(DE)
INCD
LD(HL),A
INCHL
DJNZGET1
CALLSCREEN_TO_PIXEL
JPSPRINT
SAVE_FILE
LDA,0B0H
LDDE,NAME_CHAR
EXOS2
LDDE,4000H
LDBC,4000H
LDA,0B0H
EXOS8
LDA,0B0H
LDDE,PALETTE
LDBC,9
EXOS8
LOAD1
LDA,0B0H
EXOS3
JPSPRINT
LOAD_FILE
LDA,0B0H
LDDE,NAME_CHAR
EXOS1
JRNZ,LOAD1
LDDE,4000H
LDBC,4000H
LDA,0B0H
EXOS6
LDDE,PALETTE
LDBC,9
LDA,0B0H
EXOS6
LDA,(BIAS)
OUT(80H),A
LDA,0B0H
EXOS3
CALLCHAR_SET_PRINT
LDHL,0C010H
LDIX,PALETTE
CALLSET_PALETTE
JPSPRINT
NAME_CHARDB10,"EDITOR.CHA"
NAME_BLOCKDB10,"EDITOR.TRK"
INVERT
LDIX,PALETTE
LDIY,0CA80H+2*24+8
LDDE,16
LDC,16
INV2
LDB,8
INV1
LDA,(IY)
SRLA
SRLA
SRLA
SRLA
XOR0FH
PUSHDE
CALLPAPER_TO_INK
POPDE
LD(IY),A
INCIY
DJNZINV1
ADDIY,DE
DECC
JRNZ,INV2
JPSPRINT

GETSCADD_;BC=Y,X
LDBC,(POS_X)
LDL,B
LDH,0
LDA,C
ADDHL,HL
ADDHL,HL
ADDHL,HL
LDC,L
LDB,H
ADDHL,HL
LDD,H
LDE,L
ADDHL,HL
ADDHL,HL
ADDHL,DE
ADDHL,BC
SRLA
LDC,A
LDB,0C0H
ADDHL,BC
RET
CONTROL_
CALLGETSCADD_
PUSHHL
CALLSCTOPU
POPHL
PUSHHL
LDA,(POS_X)
LDDE,NYIL_DATA_0
RRCA
JRNC,CON1_
LDDE,NYIL_DATA_1
CON1_
CALLSPTOSC
HALT
POPHL
CALLPUTOSC
XORA
OUT(0B5H),A
INA,(0B5H)
INCA
RETNZ
LDIX,POS_X
LDHL,STEP
LDA,7
OUT(0B5H),A
INA,(0B5H)
BIT5,A
CALLZ,LEFT__
BIT2,A
CALLZ,RIGHT__
INCIX
BIT3,A
CALLZ,UP__
BIT1,A
CALLZ,DOWN__
INCA
JRZ,SPRINT2__
LDHL,STEP_COUNTER
DEC(HL)
JRNZ,SPRINT3__
LD(HL),15
DECHL
INC(HL)
JRSPRINT3__
SPRINT2__
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
SPRINT3__
LDA,8
OUT(0B5H),A
INA,(0B5H)
BIT6,A
JRZ,FIRE__
JRCONTROL_
FIRE__
LDA,(POS_Y)
CP112
FIRE_CHAR_SET_ADDRESS
JPNC,FIRE_CHAR_SET
CP16
JPC,FIRE_MENU
FBT_ADDRESS
JPFIRE_BLOCK_TABLE
FIRE_CHAR_SET
CALLBORDER_LINE_
LDBC,(POS_X)
LDE,-1
LDA,B
SUB112
DIV_18_
SUB18
INCE
JRNC,DIV_18_
LDD,-1
LDA,C
SUB8
JPC,BORDER_L1
CP160
JRNC,BORDER_L1
DIV_10_
SUB10
INCD
JRNC,DIV_10_
LDA,E
RLCA
RLCA
RLCA
RLCA
ADDA,D
LD(CHAR_POS),A
BORDER_L1
CALLBORDER_LINE_
JPCONTROL_
DOWN__
LDB,186-5
PUSHAF
LDA,(POS_Y)
ADDA,(HL)
CP186-4
JRNC,LOOP_D__
LD(POS_Y),A
LOOP_C__
POPAF
RET
UP__
LDB,0
PUSHAF
LDA,(POS_Y)
SUB(HL)
JPC,LOOP_D__
LD(POS_Y),A
JRLOOP_C__
LOOP_D__
LD(IX),B
LDA,1
LD(STEP),A
LDA,15
LD(STEP_COUNTER),A
POPAF
RET
LEFT__
LDB,0
PUSHAF
LDA,(POS_X)
SUB(HL)
JRC,LOOP_D__
LD(POS_X),A
JPLOOP_C__
RIGHT__
LDB,167
PUSHAF
LDA,(POS_X)
ADDA,(HL)
CP168
JRNC,LOOP_D__
LD(POS_X),A
JPLOOP_C__
BORDER_LINE_
LDA,(CHAR_POS)
LDB,A
AND15
LDC,A
ADDA,A
ADDA,A
ADDA,C
LDC,A
SRLB
SRLB
SRLB
SRLB
LDDE,18*88
LDHL,0
JRZ,BOR2_
BOR1_
ADDHL,DE
DJNZBOR1_
BOR2_
LDB,0
ADDHL,BC
LDBC,0C000H+112*88+3
ADDHL,BC
CALLBOR3_
LDDE,88
PUSHHL
POPIX
LDB,16
BOR4_
LDA,(IX)
XOR15H
LD(IX),A
LDA,(IX+5)
XOR2AH
LD(IX+5),A
ADDIX,DE
DJNZBOR4_
PUSHIX
POPHL
BOR3_
LDDE,88-5
LDC,2
BOR5_
LDB,4
LDA,(HL)
XOR15H
LD(HL),A
INCHL
BOR6_
LDA,(HL)
XOR3FH
LD(HL),A
INCHL
DJNZBOR6_
LDA,(HL)
XOR2AH
LD(HL),A
ADDHL,DE
DECC
JRNZ,BOR5_
RET
CHAR_SET_PRINT_
LDA,(CHAR_SET)
RRCA
RRCA
LDL,A
LDIX,0C000H+2*88+4+112*88
LDDE,88*2
LDA,4
LDH,40H
CSP3_
EXAF,AF
LDC,16
CSP2_
LDB,16
CSP1_
LDA,(HL)
LD(IX),A
INCH
INCIX
LDA,(HL)
LD(IX),A
INCH
INCIX
LDA,(HL)
LD(IX),A
INCH
INCIX
LDA,(HL)
LD(IX),A
DECH
DECH
DECH
INCL
INCIX
INCIX
DJNZCSP1_
PUSHDE
LDDE,8
ADDIX,DE
POPDE
INCH
INCH
INCH
INCH
LDA,L
SUB16
LDL,A
DECC
JRNZ,CSP2_
ADDIX,DE
LDA,L
ADDA,16
LDL,A
EXAF,AF
LDH,40H
DECA
JRNZ,CSP3_
RET
BLOCK_EDITOR
INA,(PORT_PAGE_3)
PUSHAF
LDA,0FFH
OUT(PORT_PAGE_3),A
EI
LDHL,128
LD(POS_X),HL
HALT
DI
LDHL,LPT_BLOCK_EDITOR
LDDE,0C000H
LDBC,LBEE-LPT_BLOCK_EDITOR
LDIR
LDHL,0C010H
LDIX,PALETTE
CALLSET_PALETTE
LDHL,700H
LD(0C038H),HL
LD(0C048H),HL
LD(0C04AH),HL
POPAF
OUT(PORT_PAGE_3),A
EI
LDHL,0C000H
LDDE,0C001H
LD(HL),0
LDBC,3FFFH
LDIR
LDHL,BNUMBER
LDDE,0FFF0H
LDBC,16
LDIR
LDHL,BE_ICONS
LDA,16
LDDE,0C000H+11
BE1
LDBC,60
LDIR
EXDE,HL
LDBC,28
ADDHL,BC
EXDE,HL
DECA
JRNZ,BE1
LDHL,88-4
LD(SCREEN_WIDTH),HL
LDHL,-88*16+4
LD(SCREEN_WIDTH_16),HL
CALLBLOCK_TABLE_PRINT
CALLCHAR_SET_PRINT_
CALLBORDER_LINE_

JPCONTROL_
BNUMBER
DB"Linenumber:000"
LPT_BLOCK_EDITOR
DB256-51,2,3FH
DS13
DB256-186,0D2H,10,54,0,0,0,0
DS8
DB256-4,2,3FH
DS13
DB256-9,8,23,39,0F0H,3FH,0E9H,1
DS8
DB256-9,8,11,73H,0B8H,0FEH,0E9H,1
DS8
DB256-52,2,3FH
DS13
DB256-1,1,10,51,0,0,0,0,0,0,0,0,0,0,0,0
LBEE
FIRE_BLOCK_TABLE
LDBC,(POS_X)
LDA,B
SUB16
JPC,CONTROL_
SRLA
SRLA
SRLA
SRLA
ADDA,A
LDE,A
ADDA,A
LDB,A
ADDA,A
ADDA,A
ADDA,B
ADDA,E
LDB,A
LDA,C
CP167
JRNZ,FBT1_
LDA,170
FBT1_
SRLA
SRLA
SRLA
LDC,B
LDB,0
LDHL,(LINE_BASE)
ORA
SBCHL,BC
LDC,A
ADDHL,BC
LDA,(CHAR_SET)
RRCA
RRCA
LDB,A
LDA,(CHAR_POS)
ADDA,B
CP(HL)
JPZ,CONTROL_
LD(HL),A
CALLBLOCK_TABLE_PRINT
JPCONTROL_
BLOCK_TABLE_PRINT
LDHL,(LINE_NUMBER)
LDDE,-5
ADDHL,DE
CALLDEC_PRINT
LDIX,(LINE_BASE)
LDHL,0C000H+16*88
EXX
LDC,6
BTP1
LDB,22
BTP2
EXX
LDE,(IX)
LDD,40H
LDC,16
BTP3
LDB,4
BTP4
LDA,(DE)
INCD
LD(HL),A
INCHL
DJNZBTP4
PUSHDE
LDDE,88-4
ADDHL,DE
POPDE
DECC
JRNZ,BTP3
INCIX
LDDE,-16*88+4
ADDHL,DE
EXX
DJNZBTP2
EXX
LDDE,15*88
ADDHL,DE
LDDE,-44
ADDIX,DE
EXX
DECC
JRNZ,BTP1
RET
LINE_BASEDW8000H+5*22
SCREEN_WIDTH_16DW-82*16+4
BE_ICONS
DEFB0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0ABH,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,0ABH,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,57H,3,57H,3,57H,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,53H,0F3H,0F3H,57H,53H,0F3H,0F3H
DEFB57H,57H,3,57H,57H,57H,0FFH,0ABH
DEFB57H,0ABH,3,3,57H,57H,0ABH,3
DEFB57H,57H,0ABH,0FFH,57H,57H,0ABH,0FFH
DEFB57H,3,3,3,57H,3,57H,3
DEFB57H,3,57H,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,57H,3
DEFB57H,3,57H,3,57H,53H,3,53H
DEFB57H,53H,3,53H,57H,57H,0ABH,57H
DEFB57H,57H,3,0ABH,57H,0ABH,3,3
DEFB57H,57H,0ABH,3,57H,57H,0ABH,0FFH
DEFB57H,57H,0ABH,0FFH,57H,57H,0FFH,0FFH
DEFB57H,3,57H,3,57H,3,0FFH,0ABH
DEFB57H,3,3,0ABH,57H,3,0ABH,3
DEFB57H,3,57H,3,57H,3,57H,3
DEFB57H,53H,3,53H,57H,53H,3,53H
DEFB57H,57H,0ABH,57H,57H,57H,3,0BBH
DEFB57H,0ABH,3,3,57H,57H,0ABH,3
DEFB57H,57H,0ABH,0FFH,57H,57H,0ABH,0FFH
DEFB57H,57H,3,57H,57H,3,57H,3
DEFB57H,3,0FFH,0ABH,57H,3,57H,0ABH
DEFB57H,3,0FFH,3,57H,3,0ABH,57H
DEFB57H,57H,3,0ABH,57H,53H,3,53H
DEFB57H,53H,3,53H,57H,57H,0ABH,57H
DEFB57H,57H,3,0BBH,57H,0ABH,57H,0ABH
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,57H,3,57H
DEFB57H,57H,57H,57H,57H,57H,57H,57H
DEFB57H,3,0FFH,3,57H,3,57H,0ABH
DEFB57H,3,0ABH,57H,57H,57H,3,0ABH
DEFB57H,53H,57H,53H,57H,53H,57H,53H
DEFB57H,57H,57H,57H,57H,57H,3,0BBH
DEFB57H,0ABH,57H,0ABH,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,57H,3,57H,57H,57H,57H,57H
DEFB57H,57H,57H,57H,57H,57H,0ABH,3
DEFB57H,3,3,0FFH,57H,57H,3,0ABH
DEFB57H,3,0ABH,57H,57H,53H,3,53H
DEFB57H,53H,3,53H,57H,57H,57H,57H
DEFB57H,57H,3,0BBH,57H,0ABH,57H,0ABH
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,57H,3,57H
DEFB57H,3,0FFH,0ABH,57H,3,57H,3
DEFB57H,57H,0ABH,3,57H,3,3,0FFH
DEFB57H,57H,3,0ABH,57H,3,0ABH,57H
DEFB57H,53H,13H,53H,57H,53H,13H,53H
DEFB57H,57H,57H,57H,57H,57H,3,0BBH
DEFB57H,0ABH,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,57H,3,57H,57H,3,0FFH,0ABH
DEFB57H,3,57H,3,57H,3,0FFH,3
DEFB57H,3,57H,0ABH,57H,3,0ABH,57H
DEFB57H,57H,3,0ABH,57H,53H,13H,53H
DEFB57H,53H,13H,53H,57H,57H,3,0FFH
DEFB57H,57H,3,0BBH,57H,0ABH,3,3
DEFB57H,3,3,0FFH,57H,3,0FFH,3
DEFB57H,57H,0ABH,0FFH,57H,57H,3,57H
DEFB57H,3,57H,3,57H,3,57H,3
DEFB57H,3,57H,0ABH,57H,3,0FFH,3
DEFB57H,3,0ABH,57H,57H,57H,3,0ABH
DEFB57H,53H,0F3H,0F3H,57H,53H,0F3H,0F3H
DEFB57H,57H,3,0FFH,57H,57H,3,0BBH
DEFB57H,0ABH,3,3,57H,3,3,0FFH
DEFB57H,3,0FFH,3,57H,57H,0ABH,0FFH
DEFB57H,57H,0FFH,0FFH,57H,3,57H,3
DEFB57H,3,57H,3,57H,3,3,0ABH
DEFB57H,3,0ABH,3,57H,3,57H,3
DEFB57H,3,57H,3,57H,3,3,3
DEFB57H,3,3,3,57H,57H,3,0FFH
DEFB57H,57H,0FFH,0BBH,57H,0ABH,3,3
DEFB57H,3,3,0FFH,57H,3,0FFH,3
DEFB57H,57H,0ABH,0FFH,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,57H,3,57H,3,57H,3
DEFB57H,3,0FFH,0ABH,57H,3,57H,3
DEFB57H,57H,3,57H,57H,3,23H,13H
DEFB57H,0ABH,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,57H,0FFH,0FFH
DEFB57H,57H,0FFH,0FFH,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,57H,3
DEFB57H,3,0FFH,0ABH,57H,57H,3,57H
DEFB57H,3,33H,33H,57H,0ABH,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,3,3,3,57H,3,3,3
DEFB57H,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
DEFB0FFH,0FFH,0FFH,0FFH,0FFH
FIRE_MENU
LDA,(POS_X)
SUB22
JPC,CONTROL_
SRLA
SRLA
SRLA
CP15
JPNC,CONTROL_
ADDA,A
LDC,A
LDB,0
BE_JUMP_ADDRESS
LDHL,BE_JUMP_TABLE
ADDHL,BC
LDA,(HL)
INCHL
LDH,(HL)
LDL,A
JP(HL)
BE_JUMP_TABLE
DWCHAR_SET_1_BL
DWCHAR_SET_2_BL
DWCHAR_SET_3_BL
DWCHAR_SET_4_BL
DWCLEAR_BASE
DWINSERT
DWDELETE
DWUP_LINE
DWDOWN_LINE
DWF_UP_LINE
DWF_DOWN_LINE
DWLOAD_BLOCK_FILE
DWSAVE_BLOCK_FILE
DWCHAR_EDITOR
DWLPT_SCROLL
CHAR_SET_1_BL
XORA
CS1B
LD(CHAR_SET),A
CALLCHAR_SET_PRINT_
JPCONTROL_
CHAR_SET_2_BL
LDA,1
DB21H
CHAR_SET_3_BL
LDA,2
DB21H
CHAR_SET_4_BL
LDA,3
JRCS1B
BOX_INVERT
ADDA,A
ADDA,A
ADDA,11
LDL,A
LDH,0C0H
LDC,16
LDDE,88-4
BI2
LDB,4
BI1
LDA,(HL)
CPL
LD(HL),A
INCHL
DJNZBI1
ADDHL,DE
DECC
JRNZ,BI2
RET
LINE_NUMBERDW5
UP_LINE
LDHL,(LINE_NUMBER)
INCHL
LDDE,744
ORA
SBCHL,DE
JPNC,CONTROL_
UP2
ADDHL,DE
UP1
LD(LINE_NUMBER),HL
ADDHL,HL
LDE,L
LDD,H
ADDHL,HL
LDB,H
LDC,L
ADDHL,HL
ADDHL,HL
ADDHL,BC
ADDHL,DE
LDDE,8000H
ADDHL,DE
LD(LINE_BASE),HL
CALLBLOCK_TABLE_PRINT
CALLWAIT_SPACE
JPCONTROL_
DOWN_LINE
LDHL,(LINE_NUMBER)
LDDE,5
ORA
SBCHL,DE
JPZ,CONTROL_
ADDHL,DE
DECHL
JRUP1
F_UP_LINE
LDHL,(LINE_NUMBER)
LDDE,6
ADDHL,DE
LDDE,743
SBCHL,DE
JRC,UP2
LDHL,743
JRUP1
F_DOWN_LINE
LDHL,(LINE_NUMBER)
LDDE,6
ORA
SBCHL,DE
JRC,DOWN1
ORA
LDDE,5
SBCHL,DE
JRNC,UP2
DOWN1
LDHL,5
JRUP1
CLEAR_BASE
LDHL,(LINE_BASE)
LDDE,-5*22
ADDHL,DE
PUSHHL
POPDE
INCDE
LDA,(CHAR_SET)
RRCA
RRCA
LDB,A
LDA,(CHAR_POS)
ORB
LD(HL),A
LDBC,22*6-1
LDIR
CALLBLOCK_TABLE_PRINT
CALLWAIT_SPACE
JPCONTROL_
INSERT
LDHL,(LINE_BASE)
LDDE,-5*22
ADDHL,DE
EXDE,HL
LDHL,08000H+743*22
ORA
SBCHL,DE
JPZ,CONTROL_
LDB,H
LDC,L
LDDE,8000H+744*22-1
LDHL,8000H+743*22-1
LDDR
INS1
CALLBLOCK_TABLE_PRINT
CALLWAIT_SPACE
JPCONTROL_
DELETE
LDHL,(LINE_BASE)
LDDE,-5*22
ADDHL,DE
EXDE,HL
LDHL,08000H+743*22
ORA
SBCHL,DE
JPZ,CONTROL_
LDB,H
LDC,L
LDHL,(LINE_BASE)
LDDE,-4*22
ADDHL,DE
PUSHHL
LDDE,-22
ADDHL,DE
EXDE,HL
POPHL
LDIR
JRINS1
SAVE_BLOCK_FILE
LDA,0B0H
LDDE,NAME_BLOCK
EXOS2
LDDE,8000H
LDBC,744*22
LDA,0B0H
EXOS8
LDA,0B0H
EXOS3
JPCONTROL_
LOAD_BLOCK_FILE
LDA,0B0H
LDDE,NAME_BLOCK
EXOS1
LDDE,8000H
LDBC,744*22
LDA,0B0H
EXOS6
LDA,0B0H
EXOS3
CALLBLOCK_TABLE_PRINT
JPCONTROL_
DEC_PRINT
LDIX,-4;3SZAM+8BITURESHELYAVIDEOBAN
LDBC,100
LDE,-1
ORA
DIV1
INCE
SBCHL,BC
JRNC,DIV1
ADDHL,BC
LDA,"0"
ADDA,E
LD(IX),A
LDE,-1
LDA,L
DIV2
INCE
SUB10
JRNC,DIV2
LDB,A
LDA,"0"
ADDA,E
LD(IX+1),A
LDA,"0"+10
ADDA,B
LD(IX+2),A
RET

LPTMEMEQU0FF00H
LPT1EQU0FF10H
LPT2EQU0FF20H
LPT3EQU0FF30H
LPT4EQU0FF40H
LPT_SCROLL
DI
LDA,0FAH
OUT(0B1H),A
LDA,0FFH
OUT(0B3H),A
LDHL,744
LD(CHAR_LINE),HL
LDHL,0C000H
LDDE,4000H
LDBC,4000H
LDIR
LDA,1
LD(CHAR_COUNTER),A
LDA,0FEH
OUT(0B2H),A
INCA
OUT(0B3H),A
LDHL,LPT
PUSHHL
CALLSET_PALETTE
POPHL
LDDE,LPTMEM
LDBC,8*10H
LDIR
LDA,30H
OUT(0B4H),A;MEGSZAKITASENGEDEJEZES
LDA,0F0H
OUT(82H),A;LPTALSO12BIT
LDA,0CFH
OUT(83H),A
LDHL,IRQRUT
LD(039H),HL
LDHL,8000H
LDDE,8001H
LD(HL),0CH
LDBC,92*340-1
LDIR
LDHL,4000H
LD(CHAR_DATA),HL
EI
CONTINUE
HALT
LDA,7
OUT(0B5H),A
INA,(0B5H)
BIT4,A
JRZ,HOLD
BIT1,A
JRZ,BACKWARD
BIT3,A
JRZ,FORWARD
RRA
JRC,CONTINUE
DI
LDA,0FAH
OUT(0B1H),A
LDHL,4000H
LDBC,4000H
LDDE,0C000H
LDIR
XORA
OUT(82H),A
LDA,0CH
OUT(83H),A
OR40H
OUT(83H),A
OR80H
OUT(83H),A
LDHL,INTERRUPT
LD(39H),HL
LDA,0F9H
OUT(0B1H),A
LDA,0FCH
OUT(0B3H),A
INCA
OUT(0B2H),A
JPBLOCK_EDITOR
HOLD
DI
CALLWAIT_KEY
JRNZ,HOLD
HOLD2
CALLWAIT_KEY
DECA
BIT4,A
JRNZ,HOLD2
HOLD1
CALLWAIT_KEY
JRNZ,HOLD1
EI
JPCONTINUE
WAIT_KEY
LDA,7
OUT(0B5H),A
INA,(0B5H)
INCA
RET
BACKWARD
LDA,(STEP_C)
DECA
JRZ,CONTINUE
BACK1
LD(STEP_C),A
JRHOLD1
FORWARD
LDA,(STEP_C)
INCA
CP4
JRZ,CONTINUE
JRBACK1
;*************IRQROUTINE******************
SCROLL

LDBC,0FFA4H

LDHL,(LPT1+4)
ADDHL,BC
BIT7,H
JPNZ,LOOP1
LDHL,0E164H
LOOP1LD(LPT1+4),HL

LDHL,(LPT2+4)
ADDHL,BC
BIT7,H
JPNZ,LOOP2
LDHL,0E164H
LOOP2LD(LPT2+4),HL

LDHL,(LPT3+4)
ADDHL,BC
BIT7,H
JPNZ,LOOP3
LDHL,0E164H
LOOP3LD(LPT3+4),HL

LDHL,(LPT4+4)
ADDHL,BC
BIT7,H
JPNZ,LOOP4
LDHL,0E164H
LOOP4LD(LPT4+4),HL

LDHL,CHAR_COUNTER
DEC(HL)
JRNZ,LOOP5
LD(HL),16
LOOP7
LDA,0FDH
OUT(0B1H),A
LDHL,(CHAR_DATA)
LDDE,CHAR_PUFFER
LDBC,22
LDIR
LD(CHAR_DATA),HL
LOOP5
LDA,0F9H
OUT(0B1H),A
LDDE,(LPT1+4)
LDA,0CH
LD(DE),A
INCDE
LD(DE),A
INCDE
LDB,22
LDIX,CHAR_PUFFER
LOOP6
LDA,(IX)
LDL,A
LDA,(CHAR_COUNTER)
DECA
RLCA
RLCA
ADDA,40H
LDH,A
LDA,(HL)
LD(DE),A
INCDE
INCH
LDA,(HL)
LD(DE),A
INCDE
INCH
LDA,(HL)
LD(DE),A
INCDE
INCH
LDA,(HL)
LD(DE),A
INCDE
INCIX
DJNZLOOP6
LDA,0CH
LD(DE),A
INCDE
LD(DE),A
LDDE,(LPT1+4)
LDA,97H
CPD
JRC,NODUPL
LDHL,61C2H
ADDHL,DE
EXDE,HL
INCHL
INCHL
LDBC,88
DUPL1
LDI
LDI
LDI
LDI
LDI
LDI
LDI
LDI
LDI
LDI
LDI
JPPE,DUPL1
NODUPL
RET
IRQRUT
LDA,(STEP_C)
LDB,A
IRQ1
PUSHBC
CALLSCROLL
POPBC
DJNZIRQ1
LDA,30H
OUT(0B4H),A
EI
RETI
IRQCOUNTERDEFB2
CHAR_COUNTERDB1
CHAR_PUFFERDS22
CHAR_DATADW4000H
CHAR_LINEDW744
STEP_CDB1
IRQEND


LPT
DEFB256-30,02H,3FH,00H,0,0,0,0,0,0,0,0,0,0,0,0;20SORKERET

DEFB256-68,52H,09H,37H,00H,80H,0,0,0,1,2,3,4,5,6,7;68SORLPT1
DEFB256-68,52H,09H,37H,70H,98H,0,0,0,1,2,3,4,5,6,7;68SORLPT2
DEFB256-68,52H,09H,37H,0E0H,0B0H,0,0,0,1,2,3,4,5,6,7;68SORLPT3
DEFB256-68,0D2H,09H,37H,50H,0C9H,0,0,0,1,2,3,4,5,6,7;68SORLPT4

DEFB256-8,02H,3FH,00H,0,0,0,0,0,0,0,0,0,0,0,0;19SORKERET
DEFB256-1,02H,3FH,00H,0,0,0,0,0,0,0,0,0,0,0,0
DEFB256-1,01H,09H,20H,0,0,0,0,0,0,0,0,0,0,0,0;VSYNC



